<?php

class Smilepay_Smilepayatm_Model_Paymentmethod extends Mage_Payment_Model_Method_Abstract 
{
    protected $_code  = 'smilepayatm';

    /**
     * Cash On Delivery payment block paths
     *
     * @var string
     */
    protected $_formBlockType = 'smilepayatm/form_smilepayatmcheckout';
    //protected $_infoBlockType = 'payment/info';
    public function getInstructions()
    {
        return $this->getConfigData('instructions');
    }
    public function getDcvc()
    {
        return trim($this->getConfigData('smilepay_atm_dcvc'));
    }
    public function getVkey()
    {
        return trim($this->getConfigData('smilepay_atm_vkey'));
    }
    public function getRvg2c()
    {
        return trim($this->getConfigData('smilepay_atm_Rvg2c'));
    }
    public function getMid()
    {
        return trim($this->getConfigData('smilepay_atm_mid'));
    }
    public function getMidVal()
    {
        return trim($this->getConfigData('smilepay_atm_mid_val'));
    }
    public function getOrderPlaceRedirectUrl()
    {
        return Mage::getUrl('smilepayatm/smilepayatm/placeorder', array('_secure' => false));
    }
    public function getCurrencyLimit()
    {
        return trim($this->getConfigData('smilepay_atm_currency_limit'));
    }
    public function validate()
    {
       parent::validate();

       if( is_null($this->getDcvc()) || $this->getDcvc() == "" 
            || is_null($this->getVkey()) || $this->getVkey() == "" 
            || is_null($this->getRvg2c()) || $this->getRvg2c() == "" )
       {
           $errorCode = 'invalid_data';
           $errorMsg = Mage::helper('smilepayatm')->__("smilepay_atm_vaildate_smse_config_error");
       }
       if (isset($errorMsg)) 
       {
           Mage::throwException($errorMsg);
       }
    }

    public function isAvailable($quote = null)
    {
        $result=parent::isAvailable($quote );

        if( $result)
        {
            if($this->getCurrencyLimit()==true)
            {
                //$currency_mod = Mage::getModel('directory/currency');
                /*$currency_mod->getConfigBaseCurrencies() != 'TWD' && */
                if(  Mage::app()->getStore()->getCurrentCurrencyCode() != 'TWD')
                    return false;
            }
        }

        return $result;

    }
}

?>