<?php

class Smilepay_Smilepayc2cp_Model_Paymentmethod extends Mage_Payment_Model_Method_Abstract 
{
    protected $_code  = 'smilepayc2cp';

    /**
     * Cash On Delivery payment block paths
     *
     * @var string
     */
     
    protected $_formBlockType = 'smilepayc2cp/form_smilepayc2cpcheckout';
    //protected $_infoBlockType = 'payment/info';
    public function getInstructions()
    {
        return trim($this->getConfigData('instructions'));
    }
    public function getDcvc()
    {
        return trim($this->getConfigData('smilepay_c2cp_dcvc'));
    }
    public function getVkey()
    {
        return trim($this->getConfigData('smilepay_c2cp_vkey'));
    }
    public function getRvg2c()
    {
        return trim($this->getConfigData('smilepay_c2cp_Rvg2c'));
    }
    public function getMid()
    {
        return trim($this->getConfigData('smilepay_c2cp_mid'));
    }
    public function getMidVal()
    {
        return trim($this->getConfigData('smilepay_c2cp_mid_val'));
    }
    public function getOrderPlaceRedirectUrl()
    {
        return Mage::getUrl('smilepayc2cp/smilepayc2cp/placeorder', array('_secure' => false));
    }
    public function validate()
    {
       parent::validate();
       $session  = Mage::getSingleton('checkout/session');
       $quote_id = $session->getQuoteId();
       $quote = Mage::getModel('sales/quote')->load($quote_id );
       $billaddress = $quote->getBillingAddress();

       $name = $billaddress->getLastname() . $billaddress->getFirstname();
       $telephone = $billaddress->getTelephone();
       $shippingmethod = Mage::getSingleton('smilepayc2cp/shippingmethod');


       if( is_null($this->getDcvc()) || $this->getDcvc() == "" 
            || is_null($this->getVkey()) || $this->getVkey() == "" 
            || is_null($this->getRvg2c()) || $this->getRvg2c() == "" )
       {
           $errorCode = 'invalid_data';
           $errorMsg = Mage::helper('smilepayc2cp')->__("smilepay_c2cp_vaildate_smse_config_error");
       }


       if( !preg_match("/[^a-zA-Z0-9 ]/",$name))
       {
           $limit_name_number =10;
       }
       else
       {
           $limit_name_number =5;
       }

       if(mb_strlen($name,"utf-8") > $limit_name_number )
       {
           $errorCode = 'invalid_data';
           $errorMsg = Mage::helper('smilepayc2cp')->__("smilepay_c2cp_validate_name_error");
       }
       elseif( !preg_match("/^[0][9][0-9]{8,8}\$/", $telephone ))
       {
           $errorCode = 'invalid_data';
           $errorMsg = Mage::helper('smilepayc2cp')->__("smilepay_c2cp_validate_phone_error");
       }
       elseif(!$shippingmethod->isEmapSelected())
       {
           $errorCode = 'invalid_data';
           $errorMsg = Mage::helper('smilepayc2cp')->__("smilepay_c2cp_validate_emap_error");
       }

       if (isset($errorMsg)) 
       {
           Mage::throwException($errorMsg);
       }
    }
}

?>