<?php

class Smilepay_Smilepayc2cp_Model_Shippingmethod
extends Mage_Shipping_Model_Carrier_Abstract
implements Mage_Shipping_Model_Carrier_Interface
{
  protected $_code = 'smilepayc2cp';
  protected $emap_url = 'https://emap.presco.com.tw/c2cemap.ashx';
  const METHOD_FAMI = 'fami';
  const METHOD_711 = '711';
  protected $service_name = array(
                            self::METHOD_711,//711
                            self::METHOD_FAMI,
                        );
  protected $serivce_config = array(
                                self::METHOD_711=>array(
                                            'field_method_id'=>'smilepayc2cp',
                                            'field_active' =>'_711_active',
                                            'field_price'=> 'price',
                                            'field_name'=> 'name',
                                            
                                            'ret_controller'=>'saveEmap',
                                            'pay_subzg'=>'7NET',
                                            'csvTypeName'=>'7-11'
                                        ),
                                self::METHOD_FAMI=>array(
                                            'field_method_id'=>'fami',
                                            'field_active' =>'fami_active',
                                            'field_price'=> 'fami_price',
                                            'field_name'=> 'fami_name',

                                            'ret_controller'=>'saveEmapFami',
                                            'pay_subzg'=>'FAMI',
                                            'csvTypeName'=>'全家'
                                )
                            );
  private static $map_url = array(
                                    self::METHOD_711 => array(
                                                'mobile'=>'https://emap.presco.com.tw/c2cemapm-u.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s',
                                                'normal'=>'https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s'
                                                 ),
                                    self::METHOD_FAMI=>  array(
                                                 'mobile'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s',
                                                 'normal'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s'
                                                 ),
                                );
  
   protected static $service_cvs_query_shipment_url = array(
                                                            self::METHOD_711 => 'https://eservice.7-11.com.tw/E-Tracking/search.aspx',
                                                            self::METHOD_FAMI => 'http://www.famiport.com.tw/distribution_search.asp'          
                                                       );
  public function getMaxOrderTotal()
  {
    return $this->getConfigData('max_order_total');
  }
  public function getMinOrderTotal()
  {
    return $this->getConfigData('min_order_total');
  }

  public function getCurrencyLimit()
  {
    return trim($this->getConfigData('smilepay_c2cp_currency_limit'));
  }

  public function isActive()
  {
    $result=parent::isActive();
    if( $result)
    {
        if($this->getCurrencyLimit()==true)
        {
            if(  Mage::app()->getStore()->getCurrentCurrencyCode() != 'TWD')
                return false;
        }

    }
    return $result;
  }
  public function collectRates(Mage_Shipping_Model_Rate_Request $request)
  {
    if (!$this->isActive()) 
    {
            return false;
    }
    //check total
    $result = Mage::getModel('shipping/rate_result');
     $this->_updateFreeMethodQuote($request);
    $minTotal = $this->getConfigData('min_order_total');
    $maxTotal = $this->getConfigData('max_order_total');
    foreach($this->service_name as $service_id)
    {
        $total = $request->getBaseSubtotalInclTax()+$this->getConfigData($this->serivce_config[$service_id]['field_price']);
        
        if ((!empty($minTotal) && ($total < $minTotal)) || (!empty($maxTotal) && ($total > $maxTotal))) {
               continue;
        }    
        
        
        $result->append($this->_getDefaultRate($request,$service_id));
    }
    return $result;
  }
 
  public function getAllowedMethods()
  {
    $method = array();
    foreach($this->serivce_config as $service)
    {
         $method[$service['field_method_id']] = $this->getConfigData($service['field_name']);
    }

    return $method;
  }
 
  protected function _getDefaultRate($request,$service_id)
  {
      
    if(!$this->getConfigData($this->serivce_config[$service_id]['field_active']))
          return null;
    $rate = Mage::getModel('shipping/rate_result_method');
     
    $rate->setCarrier($this->_code);
    $rate->setCarrierTitle($this->getConfigData('title'));
  

    $rate->setMethod($this->serivce_config[$service_id]['field_method_id']);
    $rate->setMethodTitle($this->getConfigData($this->serivce_config[$service_id]['field_name']));
    $rate->setPrice($this->getConfigData( $this->serivce_config[$service_id]['field_price']));
    $rate->setCost(0);

  
    //free cost over specfic total
    if ($request->getFreeShipping() 
            ||( $this->getConfigData('free_shipping_enable') == 1  
            && !is_null( $this->getConfigData('free_shipping_subtotal'))
            && !empty($this->getConfigData('free_shipping_subtotal'))
            && $request->getBaseSubtotalInclTax() >= $this->getConfigData('free_shipping_subtotal'))
       )
    {
        $rate->setCost(0);
        $rate->setPrice(0.00);
    }
     
    return $rate;
  }





  public function getC2CpStoreData()
  {
      $session= Mage::getSingleton('smilepayc2cp/session');

      return $session->getSmilepayc2cpMapResult();

  }
  public function getC2CpStoreAddress()
  {
     
      $result = $this->getC2CpStoreData();
      return  $result['Storeaddress'];
  }
  public function getC2CpStoreId()
  {
      $result = $this->getC2CpStoreData();
      return  $result['Storeid'];
  }
  public function getC2CpStoreName()
  {
      $result = $this->getC2CpStoreData();
      return  $result['Storename'];
  }
  public function getC2CpCVSType()
  {
      $result = $this->getC2CpStoreData();
      return  $result['CVSType'];
  }
  //E-Map selected
  public function isEmapSelected()
  {
      $session  = Mage::getSingleton('checkout/session');
      $quote_id = $session->getQuoteId();
      $quote = Mage::getModel('sales/quote')->load($quote_id );
      $result = $this->getC2CpStoreData();
      $selected = true;
      $shippingAddr = $quote->getShippingAddress();
      $shippingMethod = $shippingAddr->getShippingMethod();
      $csvtype='';
      foreach($this->serivce_config as $service_id => $serivce)
      {
          if( $shippingMethod== $this->_code."_".$serivce['field_method_id'])
          {
            $csvtype= $service_id;
            break;
          }
      }
     
      if(!isset($result) || empty($result))
        $selected = false;
      else
      {
          foreach($result as $storeData)
          {
            if(!isset($storeData) || empty( $storeData))
            {
              $selected = false;
              break;
            }
            
          }
          if( $result['CVSType'] !=  $csvtype)
            $selected = false;

      }

      return  $selected;
  }
    // E-Map URL
  public function getEMapUrl($service_id='')
  {
     //map mobile start
     $useragent=$_SERVER['HTTP_USER_AGENT'];
     $isMobile=false;
     if( strpos( $useragent,'Android') === false && strpos($useragent,'iPad' ) === false && strpos( $useragent,'iPhone') === false
	        || strpos( $useragent,'Safari') === false && strpos( $useragent,'AppleWebKit') === false  && strpos( $useragent,'Dalvik') === false )
     {
        //pc
        $isMobile=false;
     }
     else
     {
        $isMobile=true;
     }
     //map mobile end
     if($isMobile)
        $emap_url = self::$map_url[$service_id]['mobile'];
     else
        $emap_url = self::$map_url[$service_id]['normal'];

     return sprintf( $emap_url,'', urlencode(Mage::getBaseUrl()."smilepayc2cp/smilepayc2cp/".$this->serivce_config[$service_id]['ret_controller']));
    
    
  }
  public function getPay_subzg($service_id)
  {
      return $this->serivce_config[$service_id]['pay_subzg'];
  }
  public function getCSVTypeName($service_id)
  {
      return $this->serivce_config[$service_id]['csvTypeName'];  
  }

  public function getShipmentQueryUrl($method)
  {
      foreach($this->serivce_config as $service_id => $serivce)
      {
          if( $method== $this->_code."_".$serivce['field_method_id'])
          {
            return self::$service_cvs_query_shipment_url[$service_id]; 
          }
         
      }
      return '';
  }

}
?>