<?php
    
class Smilepay_Smilepayc2cup_Model_Observer
{
  public function placeorderSuccess($observer) 
  {
      $event = $observer->getEvent();
    
      $order_id = $event->getOrderIds()[0];

      if(!isset($order_id) || empty($order_id))
          return;
      $order = Mage::getSingleton('sales/order');
      $order->load($order_id);
    
      $quote = Mage::getSingleton('sales/quote');
      $quote->load($order->getQuoteId());

      $shippingmethod = $quote->getShippingAddress()->getShippingMethod();


      if( strpos($shippingmethod, 'smilepayc2cup_')===0)
      {
          $controlleraction = Mage::app()->getFrontController()->getAction();
         

          //layout
          $block = $controlleraction->getLayout()->createBlock('Mage_Core_Block_Template','smilepayc2cup_message',array('template' => 'smilepayc2cup/placeorder/success.phtml'));
         

          $session= Mage::getSingleton('smilepayc2cup/session');


          $smilepayc2cup_model= Mage::getSingleton('smilepayc2cup/shippingmethod');
         //run process
          $smilepayc2cup_result = $smilepayc2cup_model->runC2CupProcess( $order->getIncrementId());
          $block = $smilepayc2cup_model->generateC2CupOrderBlock($smilepayc2cup_result);

          $session->clear();

          $checkout_success_block=$controlleraction->getLayout()->getBlock('content')->getChild('checkout.success');

          if($checkout_success_block)
             $controlleraction->getLayout()->getBlock('content')->insert($block,'checkout.success',false);
          else
             $controlleraction->getLayout()->getBlock('content')->insert($block,'',false);
      }
        


    
  }
  public function shippingMethodValidate($observer)
  {
      $event=$observer->getEvent();
      $controllerAction = $event->getControllerAction();
      $shipping_method = $controllerAction->getRequest()->getPost('shipping_method', '');
      if( strpos($shipping_method, 'smilepayc2cup_')!==0)
        return $this;

      $smilepayc2cup_model = Mage::getSingleton('smilepayc2cup/shippingmethod');
      $validate_ok = $smilepayc2cup_model->validate();

      if($validate_ok !== true){
            $message = $validate_ok;
            $result = array('error' => -1, 'message' => $message);
            $controllerAction->getResponse()->setBody(Zend_Json::encode($result));
      }
         
        return $this;
  }
  public function outputAdminOrderInfo($observer)
  {
      $block = $observer->getBlock();

      if (($block->getNameInLayout() == 'order_tab_info') ) 
      {
            $child = $block->getChild('smilepayc2cup.order.info.block');
            if($child)
            {
                $transport = $observer->getTransport();
                if ($transport)
                {
                    $html = $transport->getHtml();
                    $html .= $child->toHtml();
                    $transport->setHtml($html);
                }
            }
            
      }
  }

}
?>