<?php


class Smilepay_Smilepayc2cup_Model_Shippingmethod
extends Mage_Shipping_Model_Carrier_Abstract
implements Mage_Shipping_Model_Carrier_Interface
{
  protected $_code = 'smilepayc2cup';
  protected $smseurl = 'http://ssl.smse.com.tw/api/sppayment.asp';
  protected $emap_url = 'https://emap.presco.com.tw/c2cemap.ashx';
  const METHOD_FAMI = 'fami';
  const METHOD_711 = '711';
  protected $service_name = array(
                            self::METHOD_711,//711
                            self::METHOD_FAMI,
                        );
  protected $serivce_config = array(
                                self::METHOD_711=>array(
                                            'field_method_id'=>'smilepayc2cup',
                                            'field_active' =>'_711_active',
                                            'field_price'=> 'price',
                                            'field_name'=> 'name',
                                            
                                            'ret_controller'=>'saveEmap',
                                            'pay_subzg'=>'7NET',
                                            'csvTypeName'=>'7-11'
                                        ),
                                self::METHOD_FAMI=>array(
                                            'field_method_id'=>'fami',
                                            'field_active' =>'fami_active',
                                            'field_price'=> 'fami_price',
                                            'field_name'=> 'fami_name',

                                            'ret_controller'=>'saveEmapFami',
                                            'pay_subzg'=>'FAMI',
                                            'csvTypeName'=>'全家'
                                )
                            );
  private static $map_url = array(
                                    self::METHOD_711 => array(
                                                'mobile'=>'https://emap.presco.com.tw/c2cemapm-u.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s',
                                                'normal'=>'https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s'
                                                 ),
                                    self::METHOD_FAMI=>  array(
                                                 'mobile'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s',
                                                 'normal'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s'
                                                 ),
                                );
  
   protected static $service_cvs_query_shipment_url = array(
                                                            self::METHOD_711 => 'https://eservice.7-11.com.tw/E-Tracking/search.aspx',
                                                            self::METHOD_FAMI => 'http://www.famiport.com.tw/distribution_search.asp'          
                                                       );  
  public function getMaxOrderTotal()
  {
    return $this->getConfigData('max_order_total');
  }
  public function getMinOrderTotal()
  {
    return $this->getConfigData('min_order_total');
  }

  public function getCurrencyLimit()
  {
    return trim($this->getConfigData('smilepay_c2cup_currency_limit'));
  }
  public function isActive()
  {
    $result=parent::isActive();
    if( $result)
    {
        if($this->getCurrencyLimit()==true)
        {
            if(  Mage::app()->getStore()->getCurrentCurrencyCode() != 'TWD')
                return false;
        }

    }
    return $result;
  }
  
  public function collectRates(Mage_Shipping_Model_Rate_Request $request)
  {
    if (!$this->isActive()) 
    {
            return false;
    }
    //check total
    $result = Mage::getModel('shipping/rate_result');
     $this->_updateFreeMethodQuote($request);
    $minTotal = $this->getConfigData('min_order_total');
    $maxTotal = $this->getConfigData('max_order_total');
    foreach($this->service_name as $service_id)
    {
        $total = $request->getBaseSubtotalInclTax()+$this->getConfigData($this->serivce_config[$service_id]['field_price']);
        
        if ((!empty($minTotal) && ($total < $minTotal)) || (!empty($maxTotal) && ($total > $maxTotal))) {
               continue;
        }    
        
        
        $result->append($this->_getDefaultRate($request,$service_id));
    }
    return $result;
  }
 
  public function getAllowedMethods()
  {
    $method = array();
    foreach($this->serivce_config as $service)
    {
         $method[$service['field_method_id']] = $this->getConfigData($service['field_name']);
    }

    return $method;
  }
  
  protected function _getDefaultRate($request,$service_id)
  {
    if(!$this->getConfigData($this->serivce_config[$service_id]['field_active']))
          return null;
    $rate = Mage::getModel('shipping/rate_result_method');
     
    $rate->setCarrier($this->_code);
    $rate->setCarrierTitle($this->getConfigData('title'));
  

    $rate->setMethod($this->serivce_config[$service_id]['field_method_id']);
    $rate->setMethodTitle($this->getConfigData($this->serivce_config[$service_id]['field_name']));
    $rate->setPrice($this->getConfigData( $this->serivce_config[$service_id]['field_price']));
    $rate->setCost(0);

  
    //free cost over specfic total
    if ($request->getFreeShipping() 
            ||( $this->getConfigData('free_shipping_enable') == 1  
            && !is_null( $this->getConfigData('free_shipping_subtotal'))
            && !empty($this->getConfigData('free_shipping_subtotal'))
            && $request->getBaseSubtotalInclTax() >= $this->getConfigData('free_shipping_subtotal'))
       )
    {
        $rate->setCost(0);
        $rate->setPrice(0.00);
    }
     
    return $rate;
  }

  public function getTitle()
  {
    return $this->getConfigData('title');
  }
  public function getName()
  {
    return  $this->getConfigData('name');
  }
  
  // E-Map URL
  public function getEMapUrl($service_id='')
  {
     //map mobile start
     $useragent=$_SERVER['HTTP_USER_AGENT'];
     $isMobile=false;
     if( strpos( $useragent,'Android') === false && strpos($useragent,'iPad' ) === false && strpos( $useragent,'iPhone') === false
	        || strpos( $useragent,'Safari') === false && strpos( $useragent,'AppleWebKit') === false  && strpos( $useragent,'Dalvik') === false )
     {
        //pc
        $isMobile=false;
     }
     else
     {
        $isMobile=true;
     }
     //map mobile end
     if($isMobile)
        $emap_url = self::$map_url[$service_id]['mobile'];
     else
        $emap_url = self::$map_url[$service_id]['normal'];
    return sprintf( $emap_url,'', urlencode(Mage::getBaseUrl()."smilepayc2cup/smilepayc2cup/".$this->serivce_config[$service_id]['ret_controller']));
   
  }
  
  public function getDcvc()
  {
    return trim($this->getConfigData('smilepay_c2cup_dcvc'));
  }
  public function getVkey()
  {
    return trim($this->getConfigData('smilepay_c2cup_vkey'));
  }
  public function getRvg2c()
  {
    return trim($this->getConfigData('smilepay_c2cup_Rvg2c'));
  }
  public function getC2CupStoreData()
  {
      $session= Mage::getSingleton('smilepayc2cup/session');

      return $session->getSmilepayc2cupMapResult();

  }
  public function getC2CupStoreAddress()
  {
     
      $result = $this->getC2CupStoreData();
      return  $result['Storeaddress'];
  }
  public function getC2CupStoreId()
  {
      $result = $this->getC2CupStoreData();
      return  $result['Storeid'];
  }
  public function getC2CupStoreName()
  {
      $result = $this->getC2CupStoreData();
      return  $result['Storename'];
  }
  public function getC2CupCVSType()
  {
      $result = $this->getC2CupStoreData();
      return  $result['CVSType'];
  }
  //E-Map selected
  public function isEmapSelected()
  {
      $result = $this->getC2CupStoreData();
      $selected = true;

      $session  = Mage::getSingleton('checkout/session');
      $quote_id = $session->getQuoteId();
      $quote = Mage::getModel('sales/quote')->load($quote_id );

      $csvtype='';
      $shippingAddr = $quote->getShippingAddress();
      $shippingMethod = $shippingAddr->getShippingMethod();
      foreach($this->serivce_config as $service_id => $serivce)
      {
          if( $shippingMethod== $this->_code."_".$serivce['field_method_id'])
          {
            $csvtype= $service_id;
            break;
          }
      }

      if(!isset($result) || empty($result))
        $selected = false;
      else
      {
          foreach($result as $storeData)
          {
            if(!isset($storeData) || empty( $storeData))
            {
              $selected = false;
              break;
            }
          }
          if( $result['CVSType'] !=  $csvtype)
            $selected = false;
      }
     
      return  $selected;
  }
  public function isEmapSelectedByIncrementId($increment_id=0)
  {
      $result = $this->getC2CupStoreData();
      $selected = true;

      $session  = Mage::getSingleton('checkout/session');
      $quote_id = $session->getQuoteId();
     
      $order= Mage::getSingleton('sales/order')->loadByIncrementId($increment_id);
      $csvtype='';
    
      $shippingMethod = $order->getShippingMethod();
      foreach($this->serivce_config as $service_id => $serivce)
      {
          if( $shippingMethod== $this->_code."_".$serivce['field_method_id'])
          {
            $csvtype= $service_id;
            break;
          }
      }

      if(!isset($result) || empty($result))
        $selected = false;
      else
      {
          foreach($result as $storeData)
          {
            if(!isset($storeData) || empty( $storeData))
            {
              $selected = false;
              break;
            }
          }
          if( $result['CVSType'] !=  $csvtype)
            $selected = false;
      }
     
      return  $selected;
  }
  public function getPay_subzg($service_id)
  {
      return $this->serivce_config[$service_id]['pay_subzg'];
  }
  public function getCSVTypeName($service_id)
  {
      return $this->serivce_config[$service_id]['csvTypeName'];  
  }

  public function getShipmentQueryUrl($method)
  {
      foreach($this->serivce_config as $service_id => $serivce)
      {
          if( $method== $this->_code."_".$serivce['field_method_id'])
          {
            return self::$service_cvs_query_shipment_url[$service_id]; 
          }
         
      }
      return '';
  }

  public function validate()
  {
       //parent::validate();
       $session  = Mage::getSingleton('checkout/session');
       $quote_id = $session->getQuoteId();
       $quote = Mage::getModel('sales/quote')->load($quote_id );
       $shippingaddress = $quote->getShippingAddress();

       $name = $shippingaddress->getLastname() . $shippingaddress->getFirstname();
       $telephone = $shippingaddress->getTelephone();
       
       if( is_null($this->getDcvc()) || $this->getDcvc() == "" 
            || is_null($this->getVkey()) || $this->getVkey() == "" 
            || is_null($this->getRvg2c()) || $this->getRvg2c() == "" )
       {
           $errorCode = 'invalid_data';
           $errorMsg = Mage::helper('smilepayc2cup')->__("smilepay_c2cup_vaildate_smse_config_error");
       }
       if( !preg_match("/[^a-zA-Z0-9 ]/",$name))
       {
           $limit_name_number =10;
       }
       else
       {
           $limit_name_number =5;
       }

       if(mb_strlen($name,"utf-8") >  $limit_name_number )
       {
           $errorCode = 'invalid_data';
           $errorMsg = Mage::helper('smilepayc2cup')->__("smilepay_c2cup_validate_name_error");
       }
       elseif( !preg_match("/^[0][9][0-9]{8,8}\$/", $telephone ))
       {
           $errorCode = 'invalid_data';
           $errorMsg = Mage::helper('smilepayc2cup')->__("smilepay_c2cup_validate_phone_error");
       }
       elseif(!$this->isEmapSelected())
       {
           $errorMsg = Mage::helper('smilepayc2cup')->__("smilepay_c2cup_vaildate_emap_selected_error");
       }

     
       
       if (isset($errorMsg)) 
            return $errorMsg;
       else
            return true;
  }

  //Description: Connect to SMSe create c2cup order
  //return: SMSe result array return when success,
  //return: error array when fail,
  public function runC2CupProcess($order_increment_id)
  {
      if(!isset($order_increment_id))
      {
          $error['Status']='-1';
          $error['Desc']='Error Order id, input error!';
          return $error;
      }
      
      $order_id=$order_increment_id;

      $order= Mage::getSingleton('sales/order')->loadByIncrementId($order_id);

      if (!$order->getId()) 
      {
          $error['Status']='-2';
          $error['Desc']='Error Order id, NOT find!';
          return $error;
      }
      if(!$this->isEmapSelectedByIncrementId($order_increment_id))
      {
          $error['Status']='-3';
          $error['Desc']= Mage::helper('smilepayc2cup')->__("smilepay_c2cup_vaildate_emap_selected_order_check_error");
          return $error;
      }
      
      $customer_name =  $order->getShippingAddress()->getLastname() . $order->getShippingAddress()->getFirstname();
      $customer_email=$order->getCustomerEmail();
      $phone = $order->getShippingAddress()->getTelephone();
      $shippingAddress=$order->getShippingAddress();
      $address=  $shippingAddress->getData('region') . " " . $shippingAddress->getData('city') ." " .  $shippingAddress->getData('street');
          
      $c2cStoreData = sprintf('%s/%s/%s',$this->getC2CupStoreId(),$this->getC2CupStoreName(),$this->getC2CupStoreAddress());

      $session= Mage::getSingleton('smilepayc2cup/session');

      $result=$session->getC2CSMSeData($result);

      if( $result['Data_id']==$order_id)
      {
          //have placed
          $error['Status']='-4';
          $error['Desc']= Mage::helper('smilepayc2cup')->__("smilepay_c2cup_place_order_again_error");
          $error['place_order']= 1;
          return $error;
      }
      if($this->getCurrencyLimit()==true)
      {
          $total = $order->getGrandTotal();
      }
      else
      {
            //find TWD selected?
          if(Mage::helper('smilepayc2cup')->isCurrencyTWDselected())
              $total = $order->getGrandTotal();
          else
              $total = $order->getBaseGrandTotal();
      }
      $paysubzg = $this->getPay_subzg($this->getC2CupCVSType());

      $postdata = array(
                        'Dcvc' =>trim( $this->getDcvc()),
                        'Rvg2c' => trim($this->getRvg2c()),
                        'Verify_key' =>trim($this->getVkey()),
                        'Pay_gdry' =>'TW',
                        'Od_sob' => $order_id,
                        'Pay_zg' => 52,
                        'Pay_subzg'=> $paysubzg,
                        'Data_id' => $order_id,
                        'Amount' => intval(round($total)),
                        'Pur_name' => $customer_name,
                        'Tel_number' =>  $phone,
                        'Mobile_number' => $phone,
                       // 'Address' => $address,
                        'Email' => $customer_email,
                        'Logistics_store' =>$c2cStoreData,
                        //'Roturl' => Mage::getUrl("smilepayc2cup/smilepayc2cup/paid") ,
                        //'MapRoturl' =>Mage::getUrl("smilepayc2cup/smilepayc2cup/mapreturn") ,
                        //'Roturl_status'=>'magento1.8.1_Ok',
                    );

        //connection start
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$this->smseurl);
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch,CURLOPT_POSTFIELDS,http_build_query( $postdata));
       
        $resultxml=curl_exec($ch); 
        curl_close($ch);
       
        if(!is_null( $resultxml) && !empty($resultxml) )
        {
            $xml = simplexml_load_string($resultxml);
            if (isset( $xml)) 
            {
                (strlen(trim($xml->PayEndDate)) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                  
                $result= array(
                    'PayEndDate' =>urldecode($xmlPayEndDate),
                    'Amount' => strval($xml->Amount),
                    'Data_id'=> strval($xml->Data_id),
                    'Status'=> strval($xml->Status),
                    'Desc' => strval($xml->Desc),
                    'SmilePayNO'=> strval($xml->SmilePayNO),
                 );   
    
            }
            else
            {
                 $result = array(
                            'Status' => '-1000',
                            'Desc' => '取號失敗',    
                            'Data_id'=>$order_id,
                        );     
            }
        }
        else
        {
            $result = array(
                        'Status' => '-1000',
                        'Desc'=>'取號失敗',    
                        'Data_id'=>$order_id,
                    );     
        }
        $Smseid = $result['SmilePayNO'];
    
        if($result['Status']==1) // success
        {
            $result['Storename'] = $this->getC2CupStoreName();
            $result['Storeaddress'] = $this->getC2CupStoreAddress();
            $result['Storeid'] = $this->getC2CupStoreId();
            $result['Pur_name'] = $customer_name;
            $result['Mobile_number'] = $phone;

            
            $c2curl = sprintf('http://ssl.smse.com.tw/api/c2cpaymentU.asp?smseid=%s&dcvc=%s&types=web&Verify_key=%s&Pay_subzg=%s', $Smseid,trim( $this->getDcvc()),trim($this->getVkey()), $paysubzg);
            $admincomment=sprintf(Mage::helper('smilepayc2cup')->__('smilepay_c2cup_placeorder_comment_admin_success'),$result['SmilePayNO'],$result['Pur_name'],$result['Mobile_number'],$this->getTitle(),$this->getC2CupStoreId(),$this->getC2CupStoreName(),$this->getC2CupStoreAddress());
            $customercomment=sprintf(Mage::helper('smilepayc2cup')->__('smilepay_c2cup_placeorder_comment_customer_success'),$this->getTitle(),$result['Pur_name'],$result['Mobile_number'],$this->getC2CupStoreId(),$this->getC2CupStoreName(),$this->getC2CupStoreAddress());
            //note
            $order->addStatusHistoryComment( $admincomment,false);
            $history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);

            $order->save();
            $order->sendOrderUpdateEmail(true, $customercomment);
            
            //db
            $db_write=Mage::getSingleton('core/resource')->getConnection('core_write');
            
            $db_write->insert(Mage::getSingleton('core/resource')->getTableName('smilepayc2cup_record'),
                                     array("order_increment_id" =>  $result['Data_id'],
                                           "smse_id" => $Smseid,
                                           "record_url"=> $c2curl,
                                           )
                            );
            $db_write->closeConnection();

        }
        else  //fail
        {
            $admincomment=sprintf(Mage::helper('smilepayc2cup')->__('smilepay_c2cup_placeorder_comment_admin_fail'),$this->getTitle(),$result['Status'],$result['Desc']);
            $customercomment=sprintf(Mage::helper('smilepayc2cup')->__('smilepay_c2cup_placeorder_comment_customer_fail'),$this->getTitle());
            //note
            $order->addStatusHistoryComment( $admincomment,false);
            $history=$order->addStatusHistoryComment($customercomment,false);
            $history->setIsCustomerNotified(true);
            $history->setIsVisibleOnFront(1);
            $order->save();
            $order->sendOrderUpdateEmail(true, $customercomment);
        }
        $session->setC2CSMSeData($result);
        
        return $result;

  }

  //Description: Connect to SMSe create c2cup order and clear session.
  //return: SMSe result array return when success,
  //return: error array when fail,
  public function runC2CupProcessAndClear($order_increment_id)
  {
      $result=$this->runC2CupProcess();
      $session= Mage::getSingleton('smilepayc2cup/session');
      $session->clear();
      return $result;
  }

  //Description: Generate C2Cup Order Block that show order result.
  //input smsedata: the data is got from  runC2CupProcess or  runC2CupProcessAndClear. 
  //                If it is null, it will get data from session 
  //return: block data
  public function generateC2CupOrderBlock($smsedata)
  {
        $controlleraction = Mage::app()->getFrontController()->getAction();
          //run process

          //layout
        $block = $controlleraction->getLayout()->createBlock('Mage_Core_Block_Template','smilepayc2cup_message',array('template' => 'smilepayc2cup/placeorder/success.phtml'));
         

        $session= Mage::getSingleton('smilepayc2cup/session');

        $smilepayc2cup_result=$smsedata;

        // find session
        if(!isset($smilepayc2cup_result)|| empty($smilepayc2cup_result))
        {
            $session= Mage::getSingleton('smilepayc2cup/session');
            $smilepayc2cup_result =  $session->getC2CSMSeData($result);
        }

        $smilepayc2cup_model= Mage::getSingleton('smilepayc2cup/shippingmethod');
         
        $block->assign(
                        array(
                            'smilepay_c2cup_title' =>   $this->getTitle(),
                            'smilepay_c2cup_status' =>  $smilepayc2cup_result['Status'],
                            'smilepay_c2cup_storename' =>$smilepayc2cup_result['Storename'],
                            'smilepay_c2cup_storeaddress' => $smilepayc2cup_result['Storeaddress'],
                            'smilepay_c2cup_amount' => $smilepayc2cup_result['Amount'],
                            'smilepay_c2cup_storeid' => $smilepayc2cup_result['Storeid'],
                            'smilepay_c2cup_pur_name' => $smilepayc2cup_result['Pur_name'],
                            'smilepay_c2cup_data_id' => $smilepayc2cup_result['Data_id'],
                            'smilepay_c2cup_mobile_number' => $smilepayc2cup_result['Mobile_number'],
                             )
                    );
        return $block;
        
  }



}
?>