<?php

class Smilepay_Smilepaycsv_Model_Paymentmethod extends Mage_Payment_Model_Method_Abstract 
{
    protected $_code  = 'smilepaycsv';

    /**
     * Cash On Delivery payment block paths
     *
     * @var string
     */
    protected $_formBlockType = 'smilepaycsv/form_smilepaycsvcheckout';
    //protected $_infoBlockType = 'payment/info';
    public function getInstructions()
    {
        return trim($this->getConfigData('instructions'));
    }
    public function getDcvc()
    {
        return trim($this->getConfigData('smilepay_csv_dcvc'));
    }
    public function getVkey()
    {
        return trim($this->getConfigData('smilepay_csv_vkey'));
    }
    public function getRvg2c()
    {
        return trim($this->getConfigData('smilepay_csv_Rvg2c'));
    }
    public function getMid()
    {
        return trim($this->getConfigData('smilepay_csv_mid'));
    }
    public function getMidVal()
    {
        return trim($this->getConfigData('smilepay_csv_mid_val'));
    }
    public function getOrderPlaceRedirectUrl()
    {
        return Mage::getUrl('smilepaycsv/smilepaycsv/placeorder', array('_secure' => false));
    }
    public function getCurrencyLimit()
    {
        return trim($this->getConfigData('smilepay_csv_currency_limit'));
    }
    public function getOrderStatus()
    {
        return trim($this->getConfigData('order_status'));
    }
    public function validate()
    {
       parent::validate();

       if( is_null($this->getDcvc()) || $this->getDcvc() == "" 
            || is_null($this->getVkey()) || $this->getVkey() == "" 
            || is_null($this->getRvg2c()) || $this->getRvg2c() == "" )
       {
           $errorCode = 'invalid_data';
           $errorMsg = Mage::helper('smilepaycsv')->__("smilepay_csv_vaildate_smse_config_error");
       }

       if (isset($errorMsg)) 
       {
           Mage::throwException($errorMsg);
       }
    }

    public function isAvailable($quote = null)
    {
        $result=parent::isAvailable($quote );

        if( $result)
        {
            if($this->getCurrencyLimit()==true)
            {
                if(  Mage::app()->getStore()->getCurrentCurrencyCode() != 'TWD')
                    return false;
            }
        }

        return $result;

    }

    public function getBarcode1($increment_id="0")
    {
        
        $resource = Mage::getSingleton('core/resource'); 
        $db_read = $resource->getConnection('core_read'); 
        $tableName = $resource->getTableName('smilepaycsv_record');
        if($db_read->isTableExists($tableName))
        {
            $results = $db_read->fetchAll("select barcode1 from $tableName where order_increment_id=" .$increment_id ." ORDER BY record_id DESC limit 1");
        }
        else
            return false;
        
        if(!empty( $results) )
            return $results[0]['barcode1'];
        else
            return false;


    }



}

?>