<?php

class Smilepay_Smilepayibon_Model_Paymentmethod extends Mage_Payment_Model_Method_Abstract 
{
    protected $_code  = 'smilepayibon';

    /**
     * Cash On Delivery payment block paths
     *
     * @var string
     */
    protected $_formBlockType = 'smilepayibon/form_smilepayiboncheckout';
    //protected $_infoBlockType = 'payment/info';
    public function getInstructions()
    {
        return trim($this->getConfigData('instructions'));
    }
    public function getDcvc()
    {
        return trim($this->getConfigData('smilepay_ibon_dcvc'));
    }
    public function getVkey()
    {
        return trim($this->getConfigData('smilepay_ibon_vkey'));
    }
    public function getRvg2c()
    {
        return trim($this->getConfigData('smilepay_ibon_Rvg2c'));
    }
    public function getMid()
    {
        return trim($this->getConfigData('smilepay_ibon_mid'));
    }
    public function getMidVal()
    {
        return trim($this->getConfigData('smilepay_ibon_mid_val'));
    }
    public function getOrderPlaceRedirectUrl()
    {
        return Mage::getUrl('smilepayibon/smilepayibon/placeorder', array('_secure' => false));
    }
    public function getCurrencyLimit()
    {
        return trim($this->getConfigData('smilepay_ibon_currency_limit'));
    }
    public function validate()
    {
       parent::validate();

       if( is_null($this->getDcvc()) || $this->getDcvc() == "" 
            || is_null($this->getVkey()) || $this->getVkey() == "" 
            || is_null($this->getRvg2c()) || $this->getRvg2c() == "" )
       {
           $errorCode = 'invalid_data';
           $errorMsg = Mage::helper('smilepayibon')->__("smilepay_ibon_vaildate_smse_config_error");
       }

       if (isset($errorMsg)) 
       {
           Mage::throwException($errorMsg);
       }
    }
    public function isAvailable($quote = null)
    {
        $result=parent::isAvailable($quote );

        if( $result)
        {
            if($this->getCurrencyLimit()==true)
            {
                if(  Mage::app()->getStore()->getCurrentCurrencyCode() != 'TWD')
                    return false;
            }
        }

        return $result;

    }
}

?>